<?php
/*
Plugin Name: LJUsers
Plugin URI: http://jenyay.net
Description: Insert Livejournal users from editor
Version: 1.0.0
Author: Jenyay
Author URI: http://jenyay.net
*/

/*  Copyright 2008  Jenyay  (email : jenyay.ilin@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
class ljusers
{
	function ljusers()
	{
		add_option('ljusers_userinfo', 'http://p-stat.livejournal.com/img/userinfo.gif');
		add_option('ljusers_community', 'http://www.livejournal.com/img/community.gif');
		
		if (function_exists ('add_shortcode') )
		{
			add_shortcode('ljuser', array (&$this, 'user_shortcode') );
			add_shortcode('ljcomm', array (&$this, 'community_shortcode') );
		
			add_filter( 'mce_buttons_3', array(&$this, 'mce_buttons') );
			add_filter( 'mce_external_plugins', array(&$this, 'mce_external_plugins') );	
			
			add_action('admin_menu',  array (&$this, 'admin') );
		}
	}
	
	function admin ()
	{
		if ( function_exists('add_options_page') ) 
		{
			add_options_page( 'LJusers Options', 'LJUsers', 8, basename(__FILE__), array (&$this, 'admin_form') );
		}
	}
	
	function admin_form()
	{
		$userinfo_url = get_option('ljusers_userinfo');
		$community_url = get_option('ljusers_community');
		
		if ( isset($_POST['submit']) ) 
		{	
		   if ( function_exists('current_user_can') && !current_user_can('manage_options') )
			  die ( _e('Hacker?', 'ljusers') );
			
			if (function_exists ('check_admin_referer') )
			{
				check_admin_referer('ljusers_form');
			}
			
			$userinfo_url = $_POST['userinfo_url'];
			$community_url = $_POST['community_url'];
			
			update_option('ljusers_userinfo', $userinfo_url);
			update_option('ljusers_community', $community_url);
		}
		?>
		<div class='wrap'>
			<h2><?php _e('LJUsers Settings', 'ljusers'); ?></h2>
			
			<form name="ljusers" method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>?page=ljusers.php&amp;updated=true">
			
				<!-- Имя ljusers_form используется в check_admin_referer -->
				<?php 
					if (function_exists ('wp_nonce_field') )
					{
						wp_nonce_field('ljusers_form'); 
					}
				?>
				
				<table class="form-table">
					<tr valign="top">
						<th scope="row"><?php _e('Userinfo image url:', 'ljusers'); ?></th>
						
						<td>
							<input type="text" name="userinfo_url" size="80" value="<?php echo $userinfo_url; ?>" />
						</td>
					</tr>
					
					<tr valign="top">
						<th scope="row"><?php _e('Community image url:', 'ljusers'); ?></th>
						
						<td>
							<input type="text" name="community_url" size="80" value="<?php echo $community_url; ?>" />
						</td>
					</tr>
				</table>
				
				<input type="hidden" name="action" value="update" />
				<input type="hidden" name="page_options" value="ljusers_userinfo,ljusers_community" />
		
				<p class="submit">
				<input type="submit" name="submit" value="<?php _e('Save Changes') ?>" />
				</p>
			</form>
		</div>
		<?
	}
	
	function user_shortcode ($atts, $content = null)
	{
		$userinfo_url = get_option ('ljusers_userinfo');
		
		return "<span style='white-space: nowrap; display: inline !important;'><a href='http://$content.livejournal.com/profile'><img src='$userinfo_url' alt='[info]' width='17' height='17' style='vertical-align: bottom; border: 0; padding-right: 1px;vertical-align:middle; margin-left: 0; margin-top: 0; margin-right: 0; margin-bottom: 0;' /></a><a href='http://$content.livejournal.com/'><b>$content</b></a></span>";
	}

	function community_shortcode ($atts, $content = null)
	{
		$community_url = get_option ('ljusers_community');
			
		return "<b><span style='white-space: nowrap;'><a href='http://community.livejournal.com/$content/profile'><img src='$community_url' alt='[info]' width='17' height='17' style='vertical-align: middle; border: 0; padding-right: 1px; margin-left: 0; margin-top: 0; margin-right: 0; margin-bottom: 0;' /></a><a href='http://community.livejournal.com/$content'><b>$content</b></a></span></b>";
	}
	
	// Load the TinyMCE plugin : editor_plugin.js (wp2.5)
	function mce_external_plugins($plugin_array) 
	{
		if (function_exists (plugins_url) )
        	$plugin_array['ljusers'] = plugins_url ('/ljusers/js/editor_plugin.js');
    	else
        	$plugin_array['ljusers'] = get_option('siteurl') . '/wp-content/plugins/ljusers/js/editor_plugin.js';

   		return $plugin_array;
	}
	
	function mce_buttons($buttons)
	{
		// Эти же имена должны быть в editor_plugin.js
		array_push($buttons, "ljusers", "ljcomm");
  		return $buttons;
	}
}

$ljusers = new ljusers();

?>